/*
 * l4xx-inter.h
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_l4xx_inter_H__
#define __LIBx1f4_l4xx_inter_H__

#define _libx1f4l2_move_l4list		x1f4_move_l4list
#define _libx1f4l2_spin_l4list		x1f4_spin_l4list

extern int _libx1f4l2_back_l4list(void *, void **, unsigned);
extern int _libx1f4l2_fast_l4list(void *, unsigned, void *);
extern int _libx1f4l2_hfix_l4list(void *, int, void *);
extern int _libx1f4l2_land_l4list
    (void *, void *, int (*) (void *, void *), void *);
extern int _libx1f4l2_link_l4list(void *, unsigned, unsigned, void *);
extern int _libx1f4l2_lock_l4list(void *, void **, unsigned);
extern int _libx1f4l2_mfix_l4list
    (void *, unsigned, unsigned, unsigned, void *);
extern int _libx1f4l2_move_l4list(void *, unsigned, unsigned);
extern int _libx1f4l2_rack_l4list(void *, void *);
extern int _libx1f4l2_rail_l4list
    (void *, void *, unsigned, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int _libx1f4l2_seek_l4list(void *, unsigned, void **);
extern int _libx1f4l2_spin_l4list(void *, unsigned, unsigned);
extern int _libx1f4l2_tack_l4list(void *);
extern int _libx1f4l2_tfix_l4list(void *, int, void *);

#endif				/* __LIBx1f4_l4xx_inter_H__ */
