/*
 * ncxx.m.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <ncxx-names.h>
#include <ncxx-types.h>

#define nclist(nclist)			((struct nclist_type *) (nclist))

int
_libx1f4l2_case_nclist(void *nclist, unsigned index, void *fast, void **seek)
{
    struct fpnode_type *fpnode_data, *fqnode_data;
    unsigned tilt = 0;

    fpnode_data = nclist(nclist)->link_a.fplist.fplink.fpnode_data[0];
    fqnode_data = &nclist(nclist)->link_a.fplist.fplink;

    while (1) {
	if (0) {
	} else {
	    unsigned class;

	    class = fpnode_data->fqnode.size;

	    if (index < class) {
		tilt = 0;
	    } else {
		if (class == index) {
		    break;
		} else {
		    class++;
		    index -= class;
		    tilt = 1;
		}
	    }
	}

	fqnode_data = fpnode_data;

	fpnode_data = fpnode_data->fpnode_data[tilt];
    }

    *seek = fpnode_data;

    fqnode_data->fpnode_data[tilt] = fast;

    fqnode_data = fast;
    *fqnode_data = *fpnode_data;

    return 0;
}
