/*
 * nvxy.a.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <nvxx-inter.h>
#include <nvxx-names.h>
#include <nvxx-types.h>

#define nvlist(nvlist)			((struct nvlist_type *) (nvlist))

int
x1f4_high_nvlist(void *nvlist)
{
    int status;

    status = _libx1f4l2_ceil_nvlist(nvlist);
    if (status) {
    } else {
	nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[0] = NULL;
	nvlist(nvlist)->link_a.fplist.fplink.fqnode.size = 0;
    }

    return status;
}
