/*
 * qxcc.z.c
 * Copyright (C) 2010, 2011, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qxcc-bits.h>
#include <qxcc-defs.h>
#include <qxcc-inter.h>
#include <qxcc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qxrate(qxrate)			((struct qxrate_type *) (qxrate))

int
_libx1f4l2_moon_qxrate(void *qxrate, void **moon)
{
    int excess, status;
    unsigned delete;
    void *fpnode, *fqnode, **lqnode, *node;

    node = qxrate(qxrate)->link_a.fplist.fpnode_data;

    delete = Q_NODE(M_TEXT(node, P_ROOT(Q_NODE(node))));

    fpnode = *(void **) M_TEXT(node, L_NEXT(delete));

    lqnode = M_TEXT(node, L_LAST(delete));

    _libx1f4l2_lane_qxrate
	(qxrate, *lqnode, fpnode, M_TEXT(node, L_LAST(delete)));

    fqnode = *lqnode;

    qxrate(qxrate)->link_a.fplist.fpnode_data = fqnode;

    status = qxrate(qxrate)->link_m.free(qxrate(qxrate)->link_m.data, node);
    if (status) {
	status = FREE_ERROR;
    }

    node = qxrate(qxrate)->link_e.fplink_data;

    qxrate(qxrate)->link_a.fplist.rate--;

    *moon = fqnode;

    qxrate(qxrate)->link_e.fplink_data =
	((struct fplink_type *) node)->fplink_data;

    excess = qxrate(qxrate)->link_m.free(qxrate(qxrate)->link_m.data, node);
    if (excess) {
	if (status) {
	} else {
	    status = FREE_ERROR;
	}
    }

    return status;
}
