/*
 * scxx.k.c
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <scxx-names.h>
#include <scxx-types.h>
#include <trans.h>

#define scdeck(scdeck)			((struct scdeck_type *) (scdeck))

int
x1f4_jack_scdeck(void *scdeck, void *trans)
{
    ((struct trans_type *) trans)->data = scdeck(scdeck)->link_m.data;
    ((struct trans_type *) trans)->free = scdeck(scdeck)->link_m.free;
    ((struct trans_type *) trans)->link = scdeck(scdeck)->link_m.link;
    ((struct trans_type *) trans)->mode = scdeck(scdeck)->link_m.mode;

    return 0;
}
