/*
 * slxx-inter.h
 * Copyright (C) 2008, 2009, 2010, 2011, 2012, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_slxx_inter_H__
#define __LIBx1f4_slxx_inter_H__

#include <slxx-names.h>
#include <slxx-types.h>

#if !defined _libx1f4l2_fast_sldeck
# define _libx1f4l2_fast_sldeck		x1f4_fast_sldeck
#endif				/* !_libx1f4l2_fast_sldeck */
#if !defined _libx1f4l2_fini_sldeck
# define _libx1f4l2_fini_sldeck		x1f4_fini_sldeck
#endif				/* !_libx1f4l2_fini_sldeck */
#if !defined _libx1f4l2_flat_sldeck
# define _libx1f4l2_flat_sldeck		x1f4_flat_sldeck
#endif				/* !_libx1f4l2_flat_sldeck */
#if !defined _libx1f4l2_init_sldeck
# define _libx1f4l2_init_sldeck		x1f4_init_sldeck
#endif				/* !_libx1f4l2_init_sldeck */

extern int _libx1f4l2_blue_sldeck
    (void *, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_else_sldeck(void *, struct fpnode_type *, unsigned);
extern int _libx1f4l2_fail_sldeck(void *, struct fpnode_type *);
extern int _libx1f4l2_fast_sldeck(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_fini_sldeck(void **);
extern int _libx1f4l2_flat_sldeck(void *);
extern int _libx1f4l2_init_sldeck(void **, unsigned, struct screen_type *);
extern int _libx1f4l2_rail_sldeck
    (void *, void *, int (*) (void *, const void **, const void *),
     int (*) (void *, const void *), void *);

#endif				/* __LIBx1f4_slxx_inter_H__ */
