/*
 * tcmn.0.c
 * Copyright (C) 2009-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcmn-bits.h>
#include <tcmn-defs.h>
#include <tcmn-inter.h>
#include <tcmn-names.h>
#include <tcmn-types.h>

int
x1f4_type_tcmini(void *tcmini, unsigned copy, unsigned size)
{
    int status;

    if (3 < size) {
	unsigned slip;

	copy += 4;

	slip = size / copy;
	if (1 < slip) {
	    unsigned list = 0;

	    slip--;
	    for (; slip; slip--) {
		list += copy;
		S_NODE(tcmini, list);
		tcmini = (char *) tcmini + copy;
	    }
	    {
		S_NODE(tcmini, 0);
	    }
	} else {
	    S_NODE(tcmini, 0);
	}

	status = 0;
    } else {
	status = LINK_ERROR;
    }

    return status;
}
