/*
 * tcxx.4.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcxx-defs.h>
#include <tcxx-inter.h>
#include <tcxx-names.h>
#include <tcxx-types.h>

#define tclist(tclist)			((struct tclist_type *) (tclist))

int
x1f4_peek_tclist(void *tclist, unsigned index, void **peek)
{
    int status;

    if (!(index < tclist(tclist)->link_a.fplist.fplink.fqnode.size)) {
	status = DECK_ERROR;
    } else {
	void *tcnode;

	status = 0;

	_libx1f4l2_else_tclist(tclist, index, &tcnode);

	*peek = ((struct fpnode_type *) tcnode) + 1;
    }

    return status;
}
