/*
 * tfqb.1.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tfqp-defs.h>
#include <tfqp-inter.h>
#include <tfqp-names.h>
#include <tfqp-types.h>

#define tfline(tfline)			((struct tfline_type *) (tfline))

int
x1f4_cast_tfline(void *tfline, void *text, int (*land) (void *, void *),
		 unsigned offset)
{
    int status;

    if (tfline(tfline)->link_a.fpline.fplink.fpnode_data[0]) {
	status = _libx1f4l2_nand_tfline
	    (tfline, text, land, sizeof(struct fpnode_type) + offset, tfline,
	     _libx1f4l2_dana_tfline);
    } else {
	status = MISS_CLASS;
    }

    return status;
}
