/*
 * tfqp.2.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tfqp-inter.h>
#include <tfqp-names.h>
#include <tfqp-types.h>

int
x1f4_post_tfline(void *tfline, void *text, int (*land) (void *, void *),
		 unsigned offset, unsigned size, void **push)
{
    int status;

    status = _libx1f4l2_elif_tfline
	(tfline, text, land, sizeof(struct fpnode_type) + offset, size, push,
	 _libx1f4l2_beta_tfline);

    return status;
}
