/*
 * tsqp.3.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tsqp-defs.h>
#include <tsqp-types.h>

#define tsline(tsline)			((struct tsline_type *) (tsline))

int
x1f4_lead_tsline(void *tsline, void **peek)
{
    int status;

    if (!tsline(tsline)->link_a.fpline.fplink.fpnode_data[0]) {
	status = DECK_ERROR;
    } else {
	struct fpnode_type *fpnode_data;

	status = 0;

	fpnode_data = tsline(tsline)->link_a.fpline.fplink.fpnode_data[0];

	while (1) {
	    if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
		*peek = fpnode_data + 1;
		if (1) {
		    break;
		}
	    } else {
		fpnode_data = fpnode_data->fpnode_data[0];
	    }
	}
    }

    return status;
}
