/*
 * tvxx.h.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tvxx-names.h>
#include <tvxx-types.h>

#define tvlist(tvlist)			((struct tvlist_type *) (tvlist))

int
_libx1f4l2_moon_tvlist(void *tvlist, unsigned index, void *tvnode)
{
    struct fpnode_type *fpnode_data, *fqnode_data, *fxnode_data;
    unsigned tilt = 0;

    fxnode_data = tvlist(tvlist)->link_a.fplist.fplink.fpnode_data[0];

    fpnode_data = fxnode_data;
    fqnode_data = &tvlist(tvlist)->link_a.fplist.fplink;

    while (fpnode_data) {
	unsigned class;

	class = fpnode_data->fqnode.size;
	if (0) {
	} else {
	    struct fpnode_type *fpnode_miss;

	    fpnode_miss = fpnode_data->fpnode_data[0];
	    if (!fpnode_miss) {
		if (!index) {
		    tilt = 0;
		} else {
		    if (0) {
		    } else {
			index--;
			tilt = 1;
		    }
		}
	    } else {
		unsigned Class;

		Class = fpnode_miss->fqnode.size;
		if (Class == index) {
		    tilt = 0;
		} else {
		    if (index < Class) {
			tilt = 0;
		    } else {
			index -= Class + 1;
			tilt = 1;
		    }
		}
	    }
	}

	if (fpnode_data->fqnode.tilt) {
	    fxnode_data = fpnode_data;
	}

	fpnode_data->fqnode.size = class + 1;

	fqnode_data = fpnode_data;
	fpnode_data = fpnode_data->fpnode_data[tilt];
    }

    if (0) {
    } else {
	struct fpnode_type *fnnode_data;

	fnnode_data = tvnode;

	fnnode_data->fpnode_data[0] = NULL;
	fnnode_data->fpnode_data[1] = NULL;

	fnnode_data->fqnode.size = 1;
	fnnode_data->fqnode.tilt = 0;

	fqnode_data->fpnode_data[tilt] = fnnode_data;

	if (!fxnode_data) {
	    fnnode_data->uplink_data = NULL;
	} else {
	    fpnode_data = fnnode_data;

	    fnnode_data->uplink_data = fqnode_data;

	    do {
		fqnode_data = fpnode_data->uplink_data;
		if (fpnode_data == fqnode_data->fpnode_data[0]) {
		    fqnode_data->fqnode.tilt--;
		} else {
		    fqnode_data->fqnode.tilt++;
		}

		fpnode_data = fqnode_data;
	    } while (fpnode_data != fxnode_data);

	    if (fxnode_data->fqnode.tilt == -2) {
		if (1) {
		    struct fpnode_type *fvnode_data, *fwnode_data;

		    fvnode_data = fxnode_data->fpnode_data[0];
		    if (fvnode_data->fqnode.tilt == -1) {
			struct fpnode_type *fmnode_data;
			unsigned sx_m, sx_v, sx_x;

			fwnode_data = fvnode_data;
			fmnode_data = fvnode_data->fpnode_data[1];
			fxnode_data->fpnode_data[0] = fmnode_data;
			fvnode_data->fpnode_data[1] = fxnode_data;
			fvnode_data->fqnode.tilt = 0;
			fxnode_data->fqnode.tilt = 0;
			fvnode_data->uplink_data = fxnode_data->uplink_data;
			fxnode_data->uplink_data = fvnode_data;
			if (fmnode_data) {
			    fmnode_data->uplink_data = fxnode_data;
			    sx_m = fmnode_data->fqnode.size;
			} else {
			    sx_m = 0;
			}
			if (1) {
			    sx_v = fvnode_data->fqnode.size;
			    sx_x = fxnode_data->fqnode.size;
			    fvnode_data->fqnode.size = sx_x;
			    fxnode_data->fqnode.size = sx_x + sx_m - sx_v;
			}
		    } else {
			int slip;
			struct fpnode_type *fbnode_data, *fdnode_data;
			unsigned sx_b, sx_d, sx_w, sx_v, sx_x;

			fwnode_data = fvnode_data->fpnode_data[1];
			fbnode_data = fwnode_data->fpnode_data[0];
			fvnode_data->fpnode_data[1] = fbnode_data;
			fwnode_data->fpnode_data[0] = fvnode_data;
			fdnode_data = fwnode_data->fpnode_data[1];
			fxnode_data->fpnode_data[0] = fdnode_data;
			fwnode_data->fpnode_data[1] = fxnode_data;
			slip = fwnode_data->fqnode.tilt;
			fwnode_data->fqnode.tilt = 0;
			if (slip == -1) {
			    fvnode_data->fqnode.tilt = 0;
			    fxnode_data->fqnode.tilt = 1;
			} else {
			    if (!slip) {
				fvnode_data->fqnode.tilt = 0;
				fxnode_data->fqnode.tilt = 0;
			    } else {
				fvnode_data->fqnode.tilt = -1;
				fxnode_data->fqnode.tilt = 0;
			    }
			}
			fwnode_data->uplink_data = fxnode_data->uplink_data;
			fvnode_data->uplink_data = fwnode_data;
			fxnode_data->uplink_data = fwnode_data;
			if (fbnode_data) {
			    fbnode_data->uplink_data = fvnode_data;
			    sx_b = fbnode_data->fqnode.size;
			} else {
			    sx_b = 0;
			}
			if (fdnode_data) {
			    fdnode_data->uplink_data = fxnode_data;
			    sx_d = fdnode_data->fqnode.size;
			} else {
			    sx_d = 0;
			}
			if (1) {
			    sx_v = fvnode_data->fqnode.size;
			    sx_w = fwnode_data->fqnode.size;
			    sx_x = fxnode_data->fqnode.size;
			    fvnode_data->fqnode.size = sx_v + sx_b - sx_w;
			    fwnode_data->fqnode.size = sx_x;
			    fxnode_data->fqnode.size = sx_x + sx_d - sx_v;
			}
		    }
		    fvnode_data = fwnode_data->uplink_data;
		    if (fvnode_data) {
			if (fxnode_data == fvnode_data->fpnode_data[0]) {
			    fvnode_data->fpnode_data[0] = fwnode_data;
			} else {
			    fvnode_data->fpnode_data[1] = fwnode_data;
			}
		    } else {
			tvlist(tvlist)->link_a.fplist.fplink.fpnode_data[0] =
			    fwnode_data;
		    }
		}
	    } else {
		if (fxnode_data->fqnode.tilt == 2) {
		    struct fpnode_type *fvnode_data, *fwnode_data;

		    fvnode_data = fxnode_data->fpnode_data[1];
		    if (fvnode_data->fqnode.tilt == 1) {
			struct fpnode_type *fmnode_data;
			unsigned sx_m, sx_v, sx_x;

			fwnode_data = fvnode_data;
			fmnode_data = fvnode_data->fpnode_data[0];
			fxnode_data->fpnode_data[1] = fmnode_data;
			fvnode_data->fpnode_data[0] = fxnode_data;
			fvnode_data->fqnode.tilt = 0;
			fxnode_data->fqnode.tilt = 0;
			fvnode_data->uplink_data = fxnode_data->uplink_data;
			fxnode_data->uplink_data = fvnode_data;
			if (fmnode_data) {
			    fmnode_data->uplink_data = fxnode_data;
			    sx_m = fmnode_data->fqnode.size;
			} else {
			    sx_m = 0;
			}
			if (1) {
			    sx_v = fvnode_data->fqnode.size;
			    sx_x = fxnode_data->fqnode.size;
			    fvnode_data->fqnode.size = sx_x;
			    fxnode_data->fqnode.size = sx_x + sx_m - sx_v;
			}
		    } else {
			int slip;
			struct fpnode_type *fbnode_data, *fdnode_data;
			unsigned sx_b, sx_d, sx_w, sx_v, sx_x;

			fwnode_data = fvnode_data->fpnode_data[0];
			fbnode_data = fwnode_data->fpnode_data[1];
			fvnode_data->fpnode_data[0] = fbnode_data;
			fwnode_data->fpnode_data[1] = fvnode_data;
			fdnode_data = fwnode_data->fpnode_data[0];
			fxnode_data->fpnode_data[1] = fdnode_data;
			fwnode_data->fpnode_data[0] = fxnode_data;
			slip = fwnode_data->fqnode.tilt;
			fwnode_data->fqnode.tilt = 0;
			if (slip == 1) {
			    fvnode_data->fqnode.tilt = 0;
			    fxnode_data->fqnode.tilt = -1;
			} else {
			    if (!slip) {
				fvnode_data->fqnode.tilt = 0;
				fxnode_data->fqnode.tilt = 0;
			    } else {
				fvnode_data->fqnode.tilt = 1;
				fxnode_data->fqnode.tilt = 0;
			    }
			}
			fwnode_data->uplink_data = fxnode_data->uplink_data;
			fvnode_data->uplink_data = fwnode_data;
			fxnode_data->uplink_data = fwnode_data;
			if (fbnode_data) {
			    fbnode_data->uplink_data = fvnode_data;
			    sx_b = fbnode_data->fqnode.size;
			} else {
			    sx_b = 0;
			}
			if (fdnode_data) {
			    fdnode_data->uplink_data = fxnode_data;
			    sx_d = fdnode_data->fqnode.size;
			} else {
			    sx_d = 0;
			}
			if (1) {
			    sx_v = fvnode_data->fqnode.size;
			    sx_w = fwnode_data->fqnode.size;
			    sx_x = fxnode_data->fqnode.size;
			    fvnode_data->fqnode.size = sx_v + sx_b - sx_w;
			    fwnode_data->fqnode.size = sx_x;
			    fxnode_data->fqnode.size = sx_x + sx_d - sx_v;
			}
		    }
		    fvnode_data = fwnode_data->uplink_data;
		    if (fvnode_data) {
			if (fxnode_data == fvnode_data->fpnode_data[0]) {
			    fvnode_data->fpnode_data[0] = fwnode_data;
			} else {
			    fvnode_data->fpnode_data[1] = fwnode_data;
			}
		    } else {
			tvlist(tvlist)->link_a.fplist.fplink.fpnode_data[0] =
			    fwnode_data;
		    }
		} else {
		}
	    }
	}
    }

    return 0;
}
