/*
 * lsas.h
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4l2_LSAS_H__
#define __LIBx1f4l2_LSAS_H__

/*
 * CBT B-tree
 */
#define __LSNOTE__			1

/*
 * sorted array radix tree
 */
#define __SFNOTE__			2

#define __BILL_FOR_NOTE__		0

#define __ASNOTE__			__SFNOTE__

#define ____ASNOTE__			__ASNOTE__

#if ____ASNOTE__ == __LSNOTE__
# define lsname				"ls"
#elif __ASNOTE__ == __SFNOTE__
# define lsname				"sf"
#endif				/* ____ASNOTE__ == __LSNOTE__ */

#if ____ASNOTE__ == __LSNOTE__
# undef __BILL_FOR_NOTE__
# define __BILL_FOR_NOTE__		1
#endif				/* ____ASNOTE__ == __LSNOTE__ */

#if ____ASNOTE__ == __LSNOTE__
# define __HEAD_PASS_NOTE__		0
#elif __ASNOTE__ == __SFNOTE__
# define __HEAD_PASS_NOTE__		1
#endif				/* ____ASNOTE__ == __LSNOTE__ */

#if ____ASNOTE__ == __LSNOTE__
# define __FIX_INTERNAL__		1
# define __FIX_EXTERNAL__		1
#elif __ASNOTE__ == __SFNOTE__
# define __FIX_INTERNAL__		0
# define __FIX_EXTERNAL__		0
#endif				/* ____ASNOTE__ == __LSNOTE__ */

#if ____ASNOTE__ == __LSNOTE__
#elif __ASNOTE__ == __SFNOTE__
# undef X1f4_LSNOTE_INNER_MASK
# define X1f4_LSNOTE_INNER_MASK		0
# undef X1f4_LSNOTE_OUTER_MASK
# define X1f4_LSNOTE_OUTER_MASK		0
#endif				/* ____ASNOTE__ == __LSNOTE__ */

#if ____ASNOTE__ == __LSNOTE__
#elif __ASNOTE__ == __SFNOTE__
# define x1f4_lsnote_type		x1f4_sfnote_type
#endif				/* ____ASNOTE__ == __LSNOTE__ */

#if ____ASNOTE__ == __LSNOTE__
#elif __ASNOTE__ == __SFNOTE__
# define x1f4_fgxq_lsnote		x1f4_fgxq_sfnote
# define x1f4_find_lsbill		x1f4_find_sfbill
# define x1f4_find_lsnote		x1f4_find_sfnote
# define x1f4_fini_lsnote		x1f4_fini_sfnote
# define x1f4_fold_lsnote		x1f4_fold_sfnote
# define x1f4_hike_lsnote		x1f4_hike_sfnote
# define x1f4_init_lsnote		x1f4_init_sfnote
# define x1f4_llxq_lsnote		x1f4_llxq_sfnote
# define x1f4_note_lsnote		x1f4_note_sfnote
# define x1f4_pass_lsbill		x1f4_pass_sfbill
# define x1f4_pass_lsnote		x1f4_pass_sfnote
# define x1f4_post_lsbill		x1f4_post_sfbill
# define x1f4_post_lsnote		x1f4_post_sfnote
# define x1f4_span_lsnote		x1f4_span_sfnote
# define x1f4_text_lsnote		x1f4_text_sfnote
#endif				/* ____ASNOTE__ == __LSNOTE__ */

#endif				/* __LIBx1f4l2_LSAS_H__ */
