/*
 * dfxx-inter.h
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_dfxx_inter_H__
#define __LIBx1f4_dfxx_inter_H__

#include <dfxx-names.h>
#include <dfxx-types.h>

#if !defined _libx1f4l2_fast_dflist
# define _libx1f4l2_fast_dflist		x1f4_fast_dflist
#endif				/* !_libx1f4l2_fast_dflist */
#if !defined _libx1f4l2_flat_dflist
# define _libx1f4l2_flat_dflist		x1f4_flat_dflist
#endif				/* !_libx1f4l2_flat_dflist */

extern int _libx1f4l2_ceil_dflist(void *);
extern int _libx1f4l2_fast_dflist(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_flat_dflist(void *);

#endif				/* __LIBx1f4_dfxx_inter_H__ */
