/*
 * qlcg.7.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_rs13_qlrate(void *qlrate, unsigned index,
		       struct fpnode_type *fpnode_data,
		       struct fpnode_type *fpnode_post)
{
#if SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1)
#else
    unsigned *deck, *fast;

    fast = fpnode_data->star;

    if (0) {
    } else {
	unsigned i;

	deck = fast + 3;

	fast = deck + 3;

	if (index < 2) {
	    if (index) {
		index--;

		fast += 3;

		if (qlrate(qlrate)->link_a.fplist.size == QLBITS - 1) {
		} else {
		    deck += 3;
		}
	    } else {
		deck -= 3;

		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;

		if (qlrate(qlrate)->link_a.fplist.size == QLBITS - 1) {
		} else {
		    deck += 3;
		}
	    }
	} else {
	    i = (index & ~1) - 1;
	    for (; i; i--) {
		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;

		fast += 3;
	    }

	    if (index & 1) {
		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;

		fast += 6;

		index--;
		if (qlrate(qlrate)->link_a.fplist.size == QLBITS - 1) {
		} else {
		    deck += 3;
		}
	    } else {
		fast += 6;

		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;

		if (qlrate(qlrate)->link_a.fplist.size == QLBITS - 1) {
		} else {
		    deck += 3;
		}
	    }
	}

	i = HALF_QLBITS - 2 - index;
	for (; i; i--) {
	    fast += 3;

	    *deck++ = *fast++;
	    *deck++ = *fast++;
	    *deck++ = *fast++;
	}

	fast = fpnode_post->star;

	i = HALF_QLBITS;
	for (; i; i--) {
	    *deck++ = *fast++;
	    *deck++ = *fast++;
	    *deck++ = *fast++;

	    fast += 3;
	}
    }

    fpnode_data->node = (QLNODE) 1 << index;
    fpnode_post->node = ~(QLNODE) 0;
#endif				/* SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1) */

    return 0;
}
