/*
 * qlcw.0.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <qlcc-names.h>
#include <qlcc-types.h>

#define road(___s, ___n) \
    ((char *) (___s) + ((___n) << 1))

#define rule(___s, ___n, ___t) \
    ((char *) (___s) + (___n) * (___t))

#define sans(___s, ___n) \
    ((char *) (___s) + (___n))

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_hv00_qlrate(void *qlrate, unsigned index,
		       struct fpnode_type *fpnode_data, QLNODE copy)
{
    unsigned mall;
    void *node;

    mall = qlrate(qlrate)->link_a.fplist.mall;

    node = fpnode_data->star;

    node = rule(node, mall, index);

    for (; copy; copy >>= 1) {
	void *file;

	file = road(node, mall);
	memcpy(node, file, mall);
	node = file;
    }
    {
	void *file;

	file = sans(node, mall);
	memcpy(node, file, mall);
    }

    return 0;
}
