/*
 * qxcc.i.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qxcc-bits.h>
#include <qxcc-names.h>
#include <qxcc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

int
_libx1f4l2_root_qxrate(void *node, void **push)
{
    unsigned epslip, scmini, scnode;

    scmini = Q_NODE(node);

    scnode = P_LIST(scmini);

    S_NODE(node, B_LIST(Q_NODE(M_TEXT(node, scnode))) | M_ROOT(scmini));

    S_NODE(M_TEXT(node, sizeof(unsigned)), 1);

    *push = M_TEXT(node, scnode);

    epslip = Q_NODE(M_TEXT(node, 0));

    S_NODE(node, epslip | B_ROOT(scnode));

    return 0;
}
