/*
 * qxcc.x.c
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qxcc-config.h>

#include <qxcc-bits.h>
#include <qxcc-names.h>
#include <qxcc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qxrate(qxrate)			((struct qxrate_type *) (qxrate))

int
_libx1f4l2_mail_qxrate(void *qxrate, void *node, unsigned text, void *bill)
{
    unsigned epnode, eqnode, eznode, scnode, sfnode, violet;

    epnode = P_ROOT(Q_NODE(node));
    eqnode = 0;

    eznode = eqnode;

    S_NODE(M_TEXT(node, sizeof(unsigned)),
	   Q_NODE(M_TEXT(node, sizeof(unsigned))) + text);

    violet = sizeof(unsigned) << 1 << qxrate(qxrate)->link_a.fplist.lock;

    while (epnode < violet) {
	unsigned class, ennode, epslip;
	void *lpnode;

	lpnode = M_TEXT(node, epnode);

	if (1) {
	    epslip = Q_NODE(lpnode);

	    lpnode = M_TEXT(lpnode, sizeof(unsigned));
	    class = Q_NODE(lpnode);
	    if (1) {
		S_NODE(lpnode, class + text);
		ennode = L_LAST(epslip);
	    } else {
	    }

	    if (Q_tilt_odd(epslip)) {
		eznode = eqnode;
	    }

	    if (ennode < violet) {
		lpnode = M_TEXT(node, ennode);

		if (1) {
		    epslip = Q_NODE(lpnode);

		    if (Q_tilt_odd(epslip)) {
			eznode = epnode;
		    }

		    eqnode = ennode;

		    lpnode = M_TEXT(lpnode, sizeof(unsigned));
		    class = Q_NODE(lpnode);
		    if (1) {
			S_NODE(lpnode, class + text);
			epnode = L_LAST(epslip);
		    } else {
		    }
		}
	    } else {
		eqnode = epnode;
		epnode = ennode;
		if (1) {
		    break;
		}
	    }
	}
    }

    if (0) {
    } else {
	unsigned epslip, exnode;
	void *lcnode, *lsslip;

	epslip = Q_NODE(node);

	scnode = P_LIST(epslip);

	lcnode = M_TEXT(node, scnode);

	sfnode = Q_NODE(lcnode);

	lsslip = M_TEXT(node, sfnode);

#if ____CLASS_INSERT__ == __SLICE_INSERT__
	S_NODE(node, B_LIST(Q_NODE(lsslip)) | M_ROOT(epslip));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

	S_NODE(M_TEXT(lcnode, sizeof(unsigned)), 1);

	lsslip = M_TEXT(node, eqnode);

	epslip = Q_NODE(lsslip);

#if ____CLASS_INSERT__ == __SLICE_INSERT__
	if (1) {
	    S_NODE(lsslip, E_LAST(epslip) | B_LAST(scnode));
	} else {
	}
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

	lsslip = M_TEXT(node, eznode);

	epslip = Q_NODE(lsslip);
	if (eznode) {
	    exnode = L_LAST(epslip);
	} else {
	    exnode = L_NEXT(epslip);
	}

	if (1) {
	    void **lise;

	    S_NODE(lcnode, B_LAST(sfnode) | B_NEXT(epnode) | B_TILT(0));

	    lise = M_TEXT(node, sfnode);
	    *lise = bill;
	    S_NODE(M_TEXT(lcnode, sizeof(unsigned)), text);
	} else {
	}

	if (1) {
	    void *lxnode;

	    epnode = exnode;

#if ____CLASS_INSERT__ == __SLICE_INSERT__
	    while (epnode ^ scnode) {
		void *lpnode;

		lpnode = M_TEXT(node, epnode);

		epslip = Q_NODE(lpnode);

		if (1) {
		    S_NODE(lpnode, V_TILT(epslip));
		    epnode = L_LAST(epslip);
		} else {
		}
	    }
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

	    lxnode = M_TEXT(node, exnode);

	    epslip = Q_NODE(lxnode);

	    if (Q_tilt_2m(epslip)) {
		if (1) {
		    unsigned esslip, evnode, ewnode;
		    void *lvnode;

		    evnode = L_LAST(epslip);

		    lvnode = M_TEXT(node, evnode);


		    esslip = Q_NODE(lvnode);

		    if (Q_TILT(esslip, -1)) {
			unsigned emnode;

			ewnode = evnode;
			emnode = L_NEXT(esslip);
			S_NODE(lxnode,
			       B_LAST(emnode) | M_NEXT(epslip) | B_TILT(0));
			S_NODE(lvnode,
			       M_LAST(esslip) | B_NEXT(exnode) | B_TILT(0));
			if (1) {
			    lxnode = M_TEXT(lxnode, sizeof(unsigned));
			    S_NODE(lxnode,
				   Q_NODE(lxnode)
				   - Q_NODE(M_TEXT(lvnode, sizeof(unsigned))));
			}
		    } else {
			unsigned ebnode, ednode, emslip;
			void *lwnode;

			ewnode = L_NEXT(esslip);

			lwnode = M_TEXT(node, ewnode);

			emslip = Q_NODE(M_TEXT(node, ewnode));

			ebnode = L_LAST(emslip);
			ednode = L_NEXT(emslip);
			emslip = M_TILT(emslip);
			S_NODE(lwnode,
			       B_LAST(evnode) | B_NEXT(exnode) | B_TILT(0));
			if (H_TILT(emslip, -1)) {
			    S_NODE(lvnode,
				   M_LAST(esslip) | B_NEXT(ebnode)
				   | B_TILT(0));
			    S_NODE(lxnode,
				   B_LAST(ednode) | M_NEXT(epslip)
				   | B_TILT(1));
			} else {
			    if (H_TILT(emslip, 0)) {
				S_NODE(lvnode,
				       M_LAST(esslip) | B_NEXT(ebnode)
				       | B_TILT(0));
				S_NODE(lxnode,
				       B_LAST(ednode) | M_NEXT(epslip)
				       | B_TILT(0));
			    } else {
				S_NODE(lvnode,
				       M_LAST(esslip) | B_NEXT(ebnode)
				       | B_TILT(-1));
				S_NODE(lxnode,
				       B_LAST(ednode) | M_NEXT(epslip)
				       | B_TILT(0));
			    }
			}
			{
			    lwnode = M_TEXT(lwnode, sizeof(unsigned));
			    S_NODE(lwnode,
				   Q_NODE(lwnode)
				   + Q_NODE(M_TEXT(lvnode, sizeof(unsigned))));
			    lxnode = M_TEXT(lxnode, sizeof(unsigned));
			    S_NODE(lxnode,
				   Q_NODE(lxnode) - Q_NODE(lwnode));
			}
		    }

		    esslip = Q_NODE(M_TEXT(node, eznode));

		    if (exnode == L_LAST(esslip)) {
			S_NODE(lsslip, B_LAST(ewnode) | E_LAST(esslip));
		    } else {
			S_NODE(lsslip, E_NEXT(esslip) | B_NEXT(ewnode));
		    }
		}
	    } else {
	    }
	}
    }

    return 0;
}
