/*
 * tfqp-inter.h
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_tfqp_inter_H__
#define __LIBx1f4_tfqp_inter_H__

#include <tfqp-names.h>
#include <tfqp-types.h>

#if !defined _libx1f4l2_fast_tfline
# define _libx1f4l2_fast_tfline		x1f4_fast_tfline
#endif				/* !_libx1f4l2_fast_tfline */
#if !defined _libx1f4l2_flat_tfline
# define _libx1f4l2_flat_tfline		x1f4_flat_tfline
#endif				/* !_libx1f4l2_flat_tfline */

extern int _libx1f4l2_beta_tfline(void *, unsigned, void **);
extern int _libx1f4l2_ceil_tfline(void *);
extern int _libx1f4l2_dana_tfline(void *, void *);
extern int _libx1f4l2_elif_tfline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **,
     int (*) (void *, unsigned, void **));
extern int _libx1f4l2_even_tfline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **,
     int (*) (void *, unsigned, void **));
extern int _libx1f4l2_fast_tfline(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_flat_tfline(void *);
extern int _libx1f4l2_join_tfline(void *, void *, void *);
extern int _libx1f4l2_nand_tfline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));

#endif				/* __LIBx1f4_tfqp_inter_H__ */
