/*
 * tfqp.k.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tfqp-defs.h>
#include <tfqp-names.h>
#include <tfqp-types.h>

#define tfline(tfline)			((struct tfline_type *) (tfline))

int
_libx1f4l2_dana_tfline(void *tfline, void *tfnode)
{
    int status;

    status = tfline(tfline)->link_m.free(tfline(tfline)->link_m.data, tfnode);
    if (status) {
	status = FREE_ERROR;
    }

    return status;
}
