/*
 * tnqp.6.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tnqp-defs.h>
#include <tnqp-inter.h>
#include <tnqp-types.h>

#define tnline(tnline)			((struct tnline_type *) (tnline))

int
x1f4_pass_tnline(void *tnline, void *text, int (*land) (void *, void *),
		 unsigned offset)
{
    int status;

    if (tnline(tnline)->link_a.fpline.fplink.fpnode_data[0]) {
	status = _libx1f4l2_nand_tnline
	    (tnline, text, land, sizeof(struct fpnode_type) + offset, tnline,
	     _libx1f4l2_dana_tnline);
	if (status == MISS_CLASS) {
	    status = 0;
	}
    } else {
	status = 0;
    }

    return status;
}
