/*
 * tvqp.8.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tvqp-names.h>
#include <tvqp-types.h>

int
x1f4_next_tvline(void **next, void *data)
{
    int delete;
    struct fpnode_type *fpnode_data, *fqnode_data;

    fpnode_data = (struct fpnode_type *) data - 1;

    fqnode_data = fpnode_data->fpnode_data[1];
    if (fqnode_data) {
	while (1) {
	    fpnode_data = fqnode_data->fpnode_data[0];
	    if (!fpnode_data) {
		*next = fqnode_data + 1;

		delete = 1;

		break;
	    } else {
		fqnode_data = fpnode_data->fpnode_data[0];
		if (!fqnode_data) {
		    *next = fpnode_data + 1;

		    delete = 1;

		    break;
		}
	    }
	}
    } else {
	while (1) {
	    fqnode_data = fpnode_data->uplink_data;
	    if (!fqnode_data) {
		delete = 0;

		break;
	    } else {
		if (fpnode_data == fqnode_data->fpnode_data[0]) {
		    *next = fqnode_data + 1;

		    delete = 1;

		    break;
		} else {
		    fpnode_data = fqnode_data->uplink_data;
		    if (!fpnode_data) {
			delete = 0;

			break;
		    } else {
			if (fqnode_data == fpnode_data->fpnode_data[0]) {
			    *next = fpnode_data + 1;

			    delete = 1;

			    break;
			} else {
			}
		    }
		}
	    }
	}
    }

    return delete;
}
