/*
 * tvxv.a.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tvxx-inter.h>
#include <tvxx-names.h>
#include <tvxx-types.h>

#define tvlist(tvlist)			((struct tvlist_type *) (tvlist))

int
x1f4_post_tvlist(void *tvlist, void *text, int (*land) (void *, void *),
		 unsigned offset, unsigned size, void **push)
{
    int status;

    status = _libx1f4l2_even_tvlist
	(tvlist, text, land, sizeof(struct fpnode_type) + offset, size, push,
	 _libx1f4l2_here_tvlist);
    if (status) {
    } else {
	tvlist(tvlist)->link_a.fplist.fplink.fqnode.size++;
    }

    return status;
}
