/*
 * tvxy.0.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tvxx-names.h>
#include <tvxx-types.h>

int
x1f4_tile_tvlist(unsigned *index, void *data)
{
    struct fpnode_type *fpnode_data;
    unsigned class = 0;

    fpnode_data = (struct fpnode_type *) data - 1;

    if (1) {
	struct fpnode_type *fqnode_data;

	fqnode_data = fpnode_data->fpnode_data[0];
	if (fqnode_data) {
	    class = fqnode_data->fqnode.size;
	}
    }

    while (1) {
	struct fpnode_type *fqnode_data;

	fqnode_data = fpnode_data->uplink_data;
	if (!fqnode_data) {
	    break;
	} else {
	    if (fpnode_data == fqnode_data->fpnode_data[1]) {
		class++;
		fpnode_data = fqnode_data->fpnode_data[0];
		if (fpnode_data) {
		    class += fpnode_data->fqnode.size;
		}
	    }

	    fpnode_data = fqnode_data->uplink_data;
	    if (!fpnode_data) {
		break;
	    } else {
		if (fqnode_data == fpnode_data->fpnode_data[1]) {
		    class++;
		    fqnode_data = fpnode_data->fpnode_data[0];
		    if (fqnode_data) {
			class += fqnode_data->fqnode.size;
		    }
		}
	    }
	}
    }

    *index = class;

    return 0;
}
