/*
 * tzqp.6.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tzqp-defs.h>
#include <tzqp-inter.h>
#include <tzqp-types.h>

#define tzline(tzline)			((struct tzline_type *) (tzline))

int
x1f4_pass_tzline(void *tzline, void *text, int (*land) (void *, void *),
		 unsigned offset)
{
    int status;

    if (tzline(tzline)->link_a.fpline.fplink.fpnode_data[0]) {
	status = _libx1f4l2_nand_tzline
	    (tzline, text, land, sizeof(struct fpnode_type) + offset, tzline,
	     _libx1f4l2_dana_tzline);
	if (status == MISS_CLASS) {
	    status = 0;
	}
    } else {
	status = 0;
    }

    return status;
}
